package com.jsowell.pile.service;

import java.util.List;

import com.jsowell.pile.domain.PileAuthCard;
import com.jsowell.pile.dto.PileAuthCardDTO;
import com.jsowell.pile.vo.uniapp.AuthCardVO;
import com.jsowell.pile.vo.web.PileAuthCardVO;

/**
 * 充电站鉴权卡Service接口
 *
 * @author jsowell
 * @date 2023-03-16
 */
public interface IPileAuthCardService {
    /**
     * 查询充电站鉴权卡
     *
     * @param id 充电站鉴权卡主键
     * @return 充电站鉴权卡
     */
    // public PileAuthCard selectPileAuthCardById(Long id);

    PileAuthCardVO getCardInfoById(Long id);

    /**
     * 查询充电站鉴权卡信息
     * @param pileAuthCard
     * @return
     */
    PileAuthCard selectPileAuthCardInfo(PileAuthCard pileAuthCard);

    /**
     * 查询充电站鉴权卡列表
     *
     * @param pileAuthCard 充电站鉴权卡
     * @return 充电站鉴权卡集合
     */
    public List<PileAuthCard> selectPileAuthCardList(PileAuthCard pileAuthCard);

    /**
     * 查询充电站鉴权卡列表
     *
     * @param dto 充电站鉴权卡
     * @return 充电站鉴权卡集合
     */
    public List<PileAuthCardVO> getPileAuthCardInfoList(PileAuthCardDTO dto);

    /**
     * 新增充电站鉴权卡
     *
     * @param pileAuthCard 充电站鉴权卡
     * @return 结果
     */
    public int insertPileAuthCard(PileAuthCard pileAuthCard);

    /**
     * 新增充电站鉴权卡
     *
     * @param dto 充电站鉴权卡
     * @return 结果
     */
    int addAuthCard(PileAuthCardDTO dto);

    /**
     * 修改充电站鉴权卡
     *
     * @param pileAuthCard 充电站鉴权卡
     * @return 结果
     */
    public int updatePileAuthCard(PileAuthCard pileAuthCard);

    public int updateCardInfo(PileAuthCardDTO dto);

    /**
     * 批量删除充电站鉴权卡
     *
     * @param ids 需要删除的充电站鉴权卡主键集合
     * @return 结果
     */
    public int deletePileAuthCardByIds(Long[] ids);

    /**
     * 删除充电站鉴权卡信息
     *
     * @param id 充电站鉴权卡主键
     * @return 结果
     */
    public int deletePileAuthCardById(Long id);

    /**
     * 停用某张卡
     * @param id
     * @return
     */
    int deactivateCard(Long id);

    int unBindingCard(PileAuthCard pileAuthCard);

    /**
     * 根据逻辑卡号查询某状态的鉴权卡信息
     * @param status
     * @param logicCard
     * @return
     */
    PileAuthCard selectSomeStatusCardInfo(String status, String logicCard);

    /**
     * 通过逻辑卡号查询卡信息
     * @param logicCard
     * @return
     */
    PileAuthCard selectCardInfoByLogicCard(String logicCard);

    /**
     * 通过memberId查询鉴权卡列表 （小程序用）
     * @param memberId
     * @return
     */
    List<AuthCardVO> getAuthCardListByMemberId(String memberId);

    /**
     * 用户绑定鉴权卡 (小程序用)
     * @param dto
     */
    int bindAuthCard(PileAuthCardDTO dto);

    /**
     * 用户解绑鉴权卡 (小程序用)
     * @param dto
     * @return
     */
    int unbindAuthCard(PileAuthCardDTO dto);
}
